﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@


Sub Class_Globals
	Private mTarget As Object
	Private mEventName As String
	
	Private UDPSocket1 As UDPSocket
	Private HostIPAdrees As String
	Private HostPort As Int
	
	Private mIPaddr As String
	Private mIPort As Int
	Private mCharger() As Int

	Private mlevelNo As Int
	Private mchargersNode() As chargersNode
	Type chargerData(EVstate As Byte, chargingState As Byte, chargingCurrents(3) As Int, phaseVoltages(3) As Int, sessionWH As Int, totalWH As Int)
	'Private chargerData As chargerData
	
	Private mapChargers As Map
	Private timeCounter As Int
	Private timerSetCurrents As Timer
	Private prevActiveSockets As Int = 0
	Private mapCurrentts As Map
	
	Private MainLimit As Boolean
	Private rotationTimeCounter As Int = 0
	Private rotationInterval As Int = 20        'seconds
	Private chargingSocketsChanged As Boolean = False
	
	Private const EV_NOT_CONNECTED As Byte = 0x00
	Private const EV_CONNECTED As Byte = 0x01
	Private const EV_WANTS_TO_CHARGE As Byte = 0x02
	Private const EV_NEEDS_VENTILATE As Byte = 0x03
	
	Private const NOT_CHARGING As Byte = 0x00
	Private const CHARGING_1PHASE As Byte = 0x01
	Private const CHARGING_3PHASE As Byte = 0x02
	
	Private const ID_OFFFSET As Int = 4
	Private const EV_STATE_OFFFSET As Int = 8
	Private const CHARGING_STATE_OFFFSET As Int = 9
	
	Private const VOLTAGES_OFFFSET As Int = 12
	Private const CURRENTS_OFFFSET As Int = 18
	Private const SESSION_WH_OFFFSET As Int = 24
	Private const TOTAL_WH_OFFFSET As Int = 28
	
	Private const CURRRENT_DIVIDER As Int =10
	Private const VOLTAGE_DIVIDER As Int = 4

	Public maxAllowedCurrent As Int
	Public TotalCurrent(3) As Int
	Public MaxTotalCurrent As Int
	Public ActiveSockets As Int
	
	Public MainCurrentLimit As Int = 32
	Public lstChargingSockets, lstForceStopped As List
	
	Public levelCalculatedCurrent As Byte

	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(TargetModule As Object, levelNo As Int, chargersNode() As chargersNode, maxCurrent As Int )
	mTarget = TargetModule
	maxAllowedCurrent = maxCurrent
	mlevelNo = levelNo
	
	mapChargers.Initialize
	mapCurrentts.Initialize
	
	lstChargingSockets.Initialize
	lstForceStopped.Initialize
	
	mchargersNode = chargersNode
	
	UDPSocket1.Initialize("UDP", 0, 36)
	
	timerSetCurrents.Initialize("timerSetCurrents", 1600)  '1500 '1000
	timerSetCurrents.Enabled = True
	
	For Each chNode As chargersNode In mchargersNode
		CreateChargersAndCurrentsMap(chNode)
	Next
		
	For Each chNode As chargersNode In mchargersNode
		ChargersSchedule(chNode)
 		
	Next
	
End Sub

Sub CreateChargersAndCurrentsMap(chrgNode As chargersNode)
	For Each chargerID As Int In chrgNode.lstChargerID
		mapCurrentts.Put(chargerID, Main.initialCurrent)
		
		Private chargData As chargerData
		chargData.Initialize
		chargData.EVstate = EV_NOT_CONNECTED
		chargData.chargingState = NOT_CHARGING
		chargData.chargingCurrents(0) = 0
		chargData.chargingCurrents(1) = 0		
		chargData.chargingCurrents(2) = 0
		
		chargData.phaseVoltages(0) = 0
		chargData.phaseVoltages(1) = 0
		chargData.phaseVoltages(2) = 0
		
		chargData.sessionWH = 0
		mapChargers.Put(chargerID, chargData)
	Next
End Sub

Sub ChargersSchedule(chrgNode As chargersNode)  'IPaddr As String, IPport As Int, Charger() As Int
	Private IPaddr As String = chrgNode.IP
	Private IPport As Int = chrgNode.Port
	'Private Charger() As Int
	
	Do While(True)
		For Each chargerID As Int In chrgNode.lstChargerID    'Charger
			SendToCharger(IPaddr, IPport, chargerID)
			Sleep(125) '1000
		Next
		Sleep(0)
	Loop
End Sub

Sub SendToCharger(IPaddr As String, IPport As Int, intChargerID As Int)
	Private bc As ByteConverter
	Private commandToSend(CRC32.SEND_LENGTH) As Byte = Array As Byte(0x55, 0xDD, 0x10, 0x00, 0x11, 0x22, 0x33, 0x44, 0x00, 0x1F, 0x02, 0x06, 0xAA, 0xBB, 0xCC, 0xDD)
	Private bytChargerID(4) As Byte = Main.IntToByteArray(intChargerID, True)
	
	bc.ArrayCopy(bytChargerID, 0, commandToSend, 4, 4)
	commandToSend(9) = mapCurrentts.Get(intChargerID)
	If commandToSend(9) > 32 Then commandToSend(9) = 32
	If commandToSend(9) < 6 Then commandToSend(9) = 0
'	Log($"$DateTime{DateTime.Now}-${IPaddr}:${IPport} ${intChargerID} ${commandToSend(9)}A "$ )
	SendDataToHost(commandToSend, CRC32.SEND_LENGTH -4, IPaddr, IPport)
		
End Sub

Sub SendDataToHost(cmdToSend() As Byte, offset As Int, DestIP As String, destPort As Int)
	Private bc As ByteConverter
	Dim sendBuffer(CRC32.SEND_LENGTH) As Byte
	bc.ArrayCopy(cmdToSend, 0, sendBuffer, 0, CRC32.SEND_LENGTH)
									
	Dim checksum(4) As Byte = CRC32.CalculateCheckSum(cmdToSend)
	bc.ArrayCopy(checksum, 0, sendBuffer, offset, checksum.Length)

	Private Packet As UDPPacket
	Packet.Initialize(sendBuffer, DestIP, destPort)
	
'	Log($"$DateTime{DateTime.Now}"$ & ":" & destPort & "-" & Main.PrintHexInfo(Packet.Data))		
	UDPSocket1.Send(Packet)
	'UDPSocket1.GetBroadcastAddress

End Sub

Sub UDP_PacketArrived (Packet As UDPPacket)
	
	Private bc As ByteConverter
	
	Private Buffer1(Packet.Data.Length) As Byte
	bc.ArrayCopy(Packet.Data,0, Buffer1,0, Packet.Length)
		
	HostIPAdrees =Packet.HostAddress
	HostPort = Packet.Port
			
	If Packet.Length = CRC32.RECEIVE_LENGTH Then
		If CRC32.CheckCheckSum(Packet.Data) = True Then
'			Log($"-----UDP----${HostIPAdrees}:${HostPort}------"$)
		'	Log(bc.HexFromBytes(Buffer1))
			
			ParseUDPData(Buffer1)
'			Log("------------------------------------------------------")
		Else
			Log("UDP CRC Error!!!")
			Log(bc.HexFromBytes(Packet.Data))
		End If
	End If
End Sub

Sub ParseUDPData(inpData() As Byte)
	Private chargerID As Int = GetIntegersData(inpData, ID_OFFFSET)  'GetChargerID(inpData)
	Private chargerData As chargerData
	
	chargerData.EVstate = inpData(EV_STATE_OFFFSET)
	chargerData.chargingState = inpData(CHARGING_STATE_OFFFSET)
	chargerData.phaseVoltages = GetShortsData(inpData, VOLTAGES_OFFFSET, VOLTAGE_DIVIDER)
	chargerData.chargingCurrents = GetShortsData(inpData, CURRENTS_OFFFSET, CURRRENT_DIVIDER)
	chargerData.sessionWH = GetIntegersData(inpData, SESSION_WH_OFFFSET)
	chargerData.totalWH = GetIntegersData(inpData, TOTAL_WH_OFFFSET)
	
	UpdateChargingSocketsList(chargerID, chargerData.chargingState)	
	mapChargers.Put(chargerID, chargerData)
	
	If chargerData.EVstate = EV_NOT_CONNECTED Then
		mapCurrentts.Put(chargerID, Main.initialCurrent)
	End If
	
'	Log($"ChargerID: ${chargerID}"$)
	
End Sub

Sub UpdateChargingSocketsList(chargerID As Int, chargingstate As Byte )  'chargingstate As Byte
	If mapChargers.ContainsKey(chargerID) = True Then
		Private chargerData As chargerData = mapChargers.Get(chargerID)
		If chargingstate <> NOT_CHARGING  Then ' socket charging		
			'Private chargerData As chargerData = mapChargers.Get(chargerID)
			If chargerData.chargingState = NOT_CHARGING Then
				lstChargingSockets.Add(chargerID)
			End If			
		Else ' socket NOT charging
			For i = 0 To lstChargingSockets.Size - 1
				If chargerID = lstChargingSockets.Get(i) Then
					lstChargingSockets.RemoveAt(i)
					Exit
				End If
			Next
		End If
		
		If chargerData.EVstate = EV_NOT_CONNECTED Then
			For i = 0 To lstForceStopped.Size - 1
				If chargerID = lstForceStopped.Get(i) Then
					lstForceStopped.RemoveAt(i)
					Exit
				End If
			Next
			
		End If
				
	End If
	
End Sub

Sub GetExistingState
	Private prActiveSockets As Int = 0
	Private prTotalCurrent() As Int = Array As Int(0,0,0)
	
	For Each chargerdata As chargerData In mapChargers.Values
		If chargerdata.chargingState <> NOT_CHARGING Then
			prActiveSockets = prActiveSockets +1
		End If
		
		prTotalCurrent(0) = prTotalCurrent(0) + chargerdata.chargingCurrents(0)
		prTotalCurrent(1) = prTotalCurrent(1) + chargerdata.chargingCurrents(1)
		prTotalCurrent(2) = prTotalCurrent(2) + chargerdata.chargingCurrents(2)
	Next
	
	If ActiveSockets <> lstChargingSockets.Size Then
		chargingSocketsChanged = True
	Else
		chargingSocketsChanged = False	
	End If
	
	ActiveSockets = lstChargingSockets.Size   'prActiveSockets
	TotalCurrent = prTotalCurrent
	MaxTotalCurrent = Main.GetMaxCurrent(prTotalCurrent)
	
End Sub

Sub GetCalculatedCurrent As Byte
	Private setCurrent As Byte
	
	If ActiveSockets > 0 Then

		If (MaxTotalCurrent - maxAllowedCurrent) < 2  Then			
			setCurrent = maxAllowedCurrent/ActiveSockets
		Else
			If chargingSocketsChanged = False Then
				Private myCalculateCurrent As Byte = maxAllowedCurrent/ActiveSockets
				Private diffCurrent As Byte = (MaxTotalCurrent - maxAllowedCurrent )/ActiveSockets
				prevActiveSockets = -1
				setCurrent = myCalculateCurrent - diffCurrent -1
			Else 'active sockets
				setCurrent = maxAllowedCurrent/ActiveSockets
			End If		
		End If

	Else
	 	setCurrent = 32		
    End If
	If MainCurrentLimit <= setCurrent Then
		setCurrent = MainCurrentLimit	
		prevActiveSockets = -1
		MainLimit = True
	Else
		MainLimit = False	
	End If
	
	Return setCurrent
	
End Sub

Sub SetChargingCurrents(CalculatedCurrent As Byte)
	
'	GetExistingState
'	Private CalculatedCurrent As Byte = GetCalculatedCurrent
	
	For Each ChargerID As Int In lstChargingSockets  'mapChargers.Keys
		Private chargerdata As chargerData = mapChargers.Get(ChargerID)
		'If chargerdata.chargingState = NOT_CHARGING Then
			'mapCurrentts.Put(ChargerID, Main.initialCurrent)
		'Else
			Private maxChargerCurrent As Int =  Main.GetMaxCurrent(chargerdata.chargingCurrents)
			Private mCurrent As Int = CalculatedCurrent - maxChargerCurrent
			If mCurrent <> 0 Then
				
				If mCurrent < 0 Then
					If ActiveSockets <> prevActiveSockets Then
						If mapCurrentts.Get(ChargerID) <> CalculatedCurrent Then timeCounter = 0					
						mapCurrentts.Put(ChargerID, CalculatedCurrent)
					End If
				Else '> 0
					If (CalculatedCurrent + (MaxTotalCurrent - maxChargerCurrent)) <= maxAllowedCurrent Then
						If mapCurrentts.Get(ChargerID) <> CalculatedCurrent Then timeCounter = 0
						'timeCounter = 0
						mapCurrentts.Put(ChargerID, CalculatedCurrent)
										 		
					End If
					
				End If
			End If
									
		'End If
	Next
'-------------------------------------------------------------------------------
	For Each ChargerID As Int In lstForceStopped
		mapCurrentts.Put(ChargerID, 0)
	Next
'------------------------------------------------------------------------------		
	If ActiveSockets = 0 Then
		timeCounter = 0
	Else
		timeCounter = timeCounter + 1
		If timeCounter >= 30 Then '10 '30
			timeCounter = 0
			' Check of currents decreased
			If MainLimit = False Then
				Private CurrentNotUsed As Int = (maxAllowedCurrent - MaxTotalCurrent)/ActiveSockets
				If ActiveSockets > 1 And CurrentNotUsed > 0 Then
					For Each ChargerID As Int In lstChargingSockets  'mapChargers.Keys
						Private chargerdata As chargerData = mapChargers.Get(ChargerID)
						Private maxChargerCurrent As Int =  Main.GetMaxCurrent(chargerdata.chargingCurrents)
						Private setCurrent As Byte = mapCurrentts.Get(ChargerID)
						If maxChargerCurrent >= setCurrent Then
							mapCurrentts.Put(ChargerID, setCurrent + CurrentNotUsed)
						End If
					Next
				End If
			End If
		End If
	End If
	
	prevActiveSockets = ActiveSockets
	
End Sub

Sub timerSetCurrents_Tick
	GetExistingState
	Private CalculCurrent As Byte = GetCalculatedCurrent
	
	If CalculCurrent >= Main.initialCurrent Then
		SetChargingCurrents(CalculCurrent)
	Else
		If lstChargingSockets.Size > 1 Then	'0
			If MainLimit = False Or Main.lstChargingSocketsPerLevel.Get(0) Mod 1000 = mlevelNo Then
				
				If rotationTimeCounter = 0 Or rotationTimeCounter >=3 Then
					Private chargerID As Int = lstChargingSockets.Get(0)
					lstForceStopped.Add(chargerID)
					lstChargingSockets.RemoveAt(0)
					mapCurrentts.Put(chargerID, 0)
					rotationTimeCounter = 0
				End If	
			End If	
		End If
	End If		
	
	levelCalculatedCurrent = CalculCurrent	
	ChargersRotation
	
End Sub

Sub ChargersRotation
	If lstForceStopped.Size > 0 Then
		rotationTimeCounter = rotationTimeCounter + 1
		If rotationTimeCounter >= rotationInterval Then
			rotationTimeCounter = 0
			Private chargerIDfromForced As Int = lstForceStopped.Get(0)
			lstForceStopped.RemoveAt(0)
'			If lstChargingSockets.Size >0 Then
'				Private chargerIDfromCharging As Int = lstChargingSockets.Get(0)
'				lstForceStopped.Add(chargerIDfromCharging)
'				lstChargingSockets.RemoveAt(0)
'				mapCurrentts.Put(chargerIDfromCharging, 0)
'			End If
			lstChargingSockets.Add(chargerIDfromForced)
			mapCurrentts.Put(chargerIDfromForced, Main.initialCurrent)
		End If
		
	Else
		rotationTimeCounter = 0	
	End If
End Sub

Sub GetIntegersData(inpData() As Byte, offset As Int) As Int
	Private bc As ByteConverter
	Private bufData(4) As Byte
	bc.ArrayCopy(inpData, offset, bufData, 0, bufData.Length)
	bc.LittleEndian = True
	Private GotData() As Int = bc.IntsFromBytes(bufData)
	Return GotData(0)

End Sub


Sub GetShortsData(inpData() As Byte, offset As Int, divider As Int) As Int()
	Private bc As ByteConverter
	Private bufData(2*3) As Byte
	bc.ArrayCopy(inpData, offset, bufData, 0, bufData.Length)
	bc.LittleEndian = True
	Private Data() As Short = bc.ShortsFromBytes(bufData)
	Private intData(3) As Int
	
	For i= 0 To Data.Length -1
		Private flCurrent As Float = Data(i)/divider '10
		intData(i) = (flCurrent +0.5)
		
	Next
	
	Return intData
	
End Sub
'
'Sub GetMaxCurrent(currents() As Int) As Int
'	Private lstCurrents As List
'	lstCurrents.Initialize
'	lstCurrents.AddAll(currents)
'	lstCurrents.Sort(False)
'	Return lstCurrents.Get(0)
'End Sub


Public Sub CreatechargerData (EVstate As Byte, chargingState As Byte, chargingCurrents() As Int, phaseVoltages() As Int, sessionWH As Int, totalWH As Int) As chargerData
	Dim t1 As chargerData
	t1.Initialize
	t1.EVstate = EVstate
	t1.chargingState = chargingState
	t1.chargingCurrents = chargingCurrents
	t1.phaseVoltages = phaseVoltages
	t1.sessionWH = sessionWH
	t1.totalWH = totalWH
	Return t1
End Sub